﻿using Trinity.Technicals;
using Zeta.CommonBot.Profile;
using Zeta.TreeSharp;
using Zeta.XmlEngine;

namespace Trinity.XmlTags
{
    // TrinityMaxDeaths tells Trinity to handle deaths and exit game after X deaths
    [XmlElement("TrinityTrashPack")]
    public class TrinityTrashPack : ProfileBehavior
    {
        private bool m_IsDone = false;
        private int iSize;
		private float iRadius;
		private string sWotB = "";
		private string sElites = "";

        public override bool IsDone
        {
            get { return m_IsDone; }
        }

        protected override Composite CreateBehavior()
        {
            return new Zeta.TreeSharp.Action(ret =>
            {
				if (Size != 0 && Radius != 0f &&
					(Size != Trinity.iSizeAllowed || Radius != Trinity.iRadiusAllowed))
                {
					Trinity.iSizeAllowed = Size;
					Trinity.iRadiusAllowed = Radius;
                    Logger.Log(TrinityLogLevel.Normal, LogCategory.UserInformation, "Trash mob pack size and radius changed to ({0},{1})", Size, Radius); 
                }
				if (WotB != null && WotB != "")
                {
					if (WotB.ToLower() == "false")
						Trinity.WotBisAllowed = false;
					else
						Trinity.WotBisAllowed = true;
                    Logger.Log(TrinityLogLevel.Normal, LogCategory.UserInformation, "The use of Wrath of the Berserzek is now: -{0}-", Trinity.WotBisAllowed); 
                }
				if (sForceIgnoreElites != null && sForceIgnoreElites != "")
				{
					if (sForceIgnoreElites.ToLower() == "false" && Trinity.ForceIgnoreElites)
						Trinity.ForceIgnoreElites = false;
					if (sForceIgnoreElites.ToLower() == "true" && !Trinity.ForceIgnoreElites)
						Trinity.ForceIgnoreElites = true;
					Logger.Log(TrinityLogLevel.Normal, LogCategory.UserInformation, "Forcing Ignore Elites: -{0}-", Trinity.ForceIgnoreElites); 
				}

				/*Settings.Combat.Misc.TrashPackSize = Size;
				Settings.Combat.Misc.TrashPackClusterRadius = Radius;*/
                /*if (Reset != null && Reset.ToLower() == "true")
                    Trinity.iDeathsThisRun = 0;*/
                m_IsDone = true;
            });
        }

        [XmlAttribute("size")]
        public int Size
        {
            get
            {
                return iSize;
            }
            set
            {
                iSize = value;
            }
        }

        [XmlAttribute("radius")]
        public float Radius
        {
            get
            {
                return iRadius;
            }
            set
            {
                iRadius = value;
            }
        }

        [XmlAttribute("wotb")]
        public string WotB
        {
            get
            {
                return sWotB;
            }
            set
            {
                sWotB = value;
            }
        }

        [XmlAttribute("elites")]
		[XmlAttribute("ForceIgnoreElites")]
        public string sForceIgnoreElites
        {
            get
            {
                return sElites;
            }
            set
            {
                sElites = value;
            }
        }

        public override void ResetCachedDone()
        {
            m_IsDone = false;
            base.ResetCachedDone();
        }
    }
}
